#ifndef SERVO_MOTOR_H_LSM__
#define SERVO_MOTOR_H_LSM__

#define SERVO_MOTOR_SUCCESS 1
#define SERVO_MOTOR_ERROR   0 // serial communication error

#define SERVO_MOTOR_CL_POS_MIN          0x280
#define SERVO_MOTOR_CL_POS_DELTA        0x1000

#define COM_REQUEST_GET_SERVO_POSITION  0x00
#define COM_REQUEST_SET_SERVO_POSITION  0x10
#define COM_REQUEST_ACTIVATE_SERVO      0x20
#define COM_REQUEST_DISACTIVATE_SERVO   0x21

class serialCL;

class ServoMotor {
private:
	unsigned char	bit_;      // bit on servo board
	serialCL*		serial_;
	bool		    activated_;

public:
	// servo motor configuration
	ServoMotor(serialCL* serialCom=NULL, 
				unsigned char boardBit=0);
	void SetBoardBit(unsigned char bit);
	void SetSerialDevice(serialCL* serialCom);

	unsigned char GetBoardBit();
	
	// servo motor control
	int  SetPosition(double p);
	int  GetPosition(double *p);
	int  Activate();
	int  Disactivate();
	bool IsActivated();
};

#endif // SERVO_MOTOR_H_LSM__