// Walker_Robot_Tripod.h: interface for the Walker_Robot_Tripod class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_WALKER_ROBOT_TRIPOD_H__D0D26994_A1A3_11D6_9FB6_002018540C37__INCLUDED_)
#define AFX_WALKER_ROBOT_TRIPOD_H__D0D26994_A1A3_11D6_9FB6_002018540C37__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Serial.h"
#include "ServoMotor.h"

typedef enum Tripod_Servo{
	SERVO_ID_ROTATE=0,
	SERVO_ID_UP_FORWARD=1,
	SERVO_ID_FO_FORWARD=2,
	SERVO_ID_UP_BACKWARD=3,
	SERVO_ID_FO_BACKWARD=4,

	TRIPOD_NBR_SERVO
} Tripod_Servo;

typedef enum Tripod_Error{
	TRIPOD_NO_ERROR,
	TRIPOD_SERIAL_ERROR,

}Tripod_Error;

#define TRIPOD_SUCCESS  1
#define TRIPOD_ERROR   0

class Walker_Robot_Tripod  
{
public:
	Tripod_Error getLastError();
	int MoveRotate(double speed, double theta);
	int MoveBackward(double speed, int distance);
	int MoveForward(double speed, int distance);
	int Reset();
	Walker_Robot_Tripod(serialCL* serial);
	virtual ~Walker_Robot_Tripod();

protected:
	Tripod_Error lastError;
	serialCL*	 serial;
	ServoMotor	 servo[TRIPOD_NBR_SERVO];
};

#endif // !defined(AFX_WALKER_ROBOT_TRIPOD_H__D0D26994_A1A3_11D6_9FB6_002018540C37__INCLUDED_)
