// walker_View.cpp : implementation of the CWalker_View class
//

#include "stdafx.h"
#include "walker_texas_ranger.h"

#include "walker_Doc.h"
#include "walker_View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CWalker_View

IMPLEMENT_DYNCREATE(CWalker_View, CView)

BEGIN_MESSAGE_MAP(CWalker_View, CView)
	//{{AFX_MSG_MAP(CWalker_View)
	ON_COMMAND(ID_MOVE_FRONT, OnMoveFront)
	ON_COMMAND(ID_MOVE_REAR, OnMoveRear)
	ON_COMMAND(ID_ROTATE_LEFT, OnRotateLeft)
	ON_COMMAND(ID_ROTATE_RIGHT, OnRotateRight)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CWalker_View construction/destruction

CWalker_View::CWalker_View(): robot(NULL)
{
	// TODO: add construction code here
	if(serial.open("COM1") != SERIAL_SUCCESS) {
		MessageBox("Serial Port Failure : Can't open port", "Communication Error");
		return;
	}
	robot = new Walker_Robot_Tripod(&serial);
}

CWalker_View::~CWalker_View()
{
	if(robot) delete robot;
	serial.close();
}

BOOL CWalker_View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CWalker_View drawing

void CWalker_View::OnDraw(CDC* pDC)
{
	CWalker_Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CWalker_View printing

BOOL CWalker_View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CWalker_View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CWalker_View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CWalker_View diagnostics

#ifdef _DEBUG
void CWalker_View::AssertValid() const
{
	CView::AssertValid();
}

void CWalker_View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CWalker_Doc* CWalker_View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWalker_Doc)));
	return (CWalker_Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CWalker_View message handlers

void CWalker_View::OnMoveFront() 
{
	// TODO: Add your command handler code here
	if(robot) robot->MoveForward(1,30*3);
}

void CWalker_View::OnMoveRear() 
{
	// TODO: Add your command handler code here
	if(robot) robot->MoveBackward(1,30*3);
}

void CWalker_View::OnRotateLeft() 
{
	// TODO: Add your command handler code here
	if(robot) robot->MoveRotate(1,0.2);
}

void CWalker_View::OnRotateRight() 
{
	// TODO: Add your command handler code here
	if(robot) robot->MoveRotate(1,-0.2);
}
